﻿
Imports System.Data
Imports System.Diagnostics
Imports Infragistics.Web.UI.GridControls

Partial Public Class _Default
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.WebHierarchicalDataGrid.DataSource = GenerateDataSource()
        Me.WebHierarchicalDataGrid.DataBind()
    End Sub

    Private Function GenerateDataSource() As DataSet
        Dim dataSource As New DataSet()
        Dim people As New DataTable()
        people.TableName = "People"
        Dim addresses As New DataTable()
        addresses.TableName = "Addresses"

        people.Columns.Add("Id", GetType(Integer))
        people.Columns.Add("Name", GetType(String))

        Dim parentPrimaryKeyColumn As DataColumn() = New DataColumn(0) {}
        parentPrimaryKeyColumn(0) = people.Columns("Id")

        people.PrimaryKey = parentPrimaryKeyColumn

        Dim row As DataRow = people.NewRow()
        row.SetField(Of Integer)("Id", 1)
        row.SetField(Of String)("Name", "Trina Friesen Carroll Mann Koch Marvin Rolfson Mitchell Bauch")
        people.Rows.Add(row)

        row = people.NewRow()
        row.SetField(Of Integer)("Id", 2)
        row.SetField(Of String)("Name", "Ovila Conn DuBuque Rohan Gleason Wunsch Daugherty Pouros Schmidt")
        people.Rows.Add(row)

        addresses.Columns.Add("Id", GetType(Integer))
        addresses.Columns.Add("Address", GetType(String))
        addresses.Columns.Add("PersonId", GetType(Integer))

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 1)
        row.SetField(Of String)("Address", "Paris")
        row.SetField(Of Integer)("PersonId", 1)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 2)
        row.SetField(Of String)("Address", "Rome")
        row.SetField(Of Integer)("PersonId", 1)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 3)
        row.SetField(Of String)("Address", "London")
        row.SetField(Of Integer)("PersonId", 2)
        addresses.Rows.Add(row)

        row = addresses.NewRow()
        row.SetField(Of Integer)("Id", 4)
        row.SetField(Of String)("Address", "LosAngeles")
        row.SetField(Of Integer)("PersonId", 2)
        addresses.Rows.Add(row)

        dataSource.Tables.Add(people)
        dataSource.Tables.Add(addresses)

        Dim relation As New DataRelation("PersonId_Id_Relation", people.Columns("Id"), addresses.Columns("PersonId"))
        dataSource.Relations.Add(relation)

        Return dataSource
    End Function

    Protected Sub WebHierarchicalDataGrid_OnInitializeRow(ByVal sender As Object, ByVal e As RowEventArgs)
        Debug.WriteLine("InitializeRow is fired")
        If e.Row.Items.Count > 0 Then
            For i As Integer = 0 To e.Row.Items.Count - 1
                If e.Row.Items(i).Text.ToLower.Contains("trina") Then
                    Dim oColumn As BoundDataField = CType(e.Row.Items(i).Column, BoundDataField)
                    oColumn.HtmlEncode = False
                    oColumn.CssClass = "nowrapHTML"
                End If
            Next
        End If
    End Sub
End Class